VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cDIBSectionSave"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "Entry for PictureBox to Gif functionality"
' ========================================================================
' cDIBSectionSave.cls
' Adapted from code by Steve McMahon at:
' http://vbaccelerator.com
'
' Here's a quote from Steve's site.
' As usual, with graphics code, running it in the IDE
' will be like watching paint dry.
' To get the techniques in these samples to perform,
' you must compile to Native Code (optimised for Fast Code).
' You can also get a significant speed increase
' (60% or more) by checking all the Advanced Optimisations settings.
'
' Modified by:
' Stephen Lebans
' Stephen@lebans.com
' and
' Franco Languasco
' MC7061@mclink.it
'
' The above statement of copyright and credit is in no way
' to be construed that the party has given permission for
' the use of their code in this project.
' ========================================================================
Option Explicit


Private Type RECT
    Left  As Long
    Top  As Long
    Right  As Long
    Bottom  As Long
End Type

Private Type BITMAP
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type

Private Type BITMAPINFOHEADER
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type

Private Type RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
End Type

Private Type DIBSECTION
    dsBm As BITMAP
    dsBmih As BITMAPINFOHEADER
    dsBitfields(2) As Long
    dshSection As Long
    dsOffset As Long
End Type

Private Type BITMAPINFO256
    bmiHeader As BITMAPINFOHEADER
    bmiColors(0 To 255) As RGBQUAD
End Type

Private Type BITMAPINFO
    BITMAPINFOHEADER As BITMAPINFOHEADER
    bmiColors(0 To 255) As RGBQUAD
End Type

Private Type BITMAPINFO16
    bmiHeader As BITMAPINFOHEADER
    bmiColors(0 To 15) As RGBQUAD
End Type

' API Declarations
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" _
(lpvDest As Any, lpvSource As Any, ByVal cbCopy As Long)

Private Declare Function GlobalAlloc Lib "kernel32" _
(ByVal wFlags As Long, ByVal lMem&) As Long

Private Declare Function GlobalLock Lib "kernel32" _
(ByVal hMem As Long) As Long

Private Declare Function GlobalUnlock Lib "kernel32" _
(ByVal hMem As Long) As Long

Private Declare Function GlobalFree Lib "kernel32" _
(ByVal hMem As Long) As Long

Private Declare Function apiGetObject Lib "gdi32" Alias "GetObjectA" _
(ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long

Private Declare Function GetTempPath Lib "kernel32" _
Alias "GetTempPathA" (ByVal nBufferLength As Long, _
ByVal lpBuffer As String) As Long

Private Declare Function GetTempFileName Lib "kernel32" _
Alias "GetTempFileNameA" (ByVal lpszPath As String, _
ByVal lpPrefixString As String, ByVal wUnique As Long, _
ByVal lpTempFileName As String) As Long

Private Declare Function CreateCompatibleDC Lib "gdi32" _
(ByVal hDC As Long) As Long

Private Declare Function GetWindowDC Lib "user32" _
(ByVal hwnd As Long) As Long

Private Declare Function DeleteDC Lib "gdi32" _
(ByVal hDC As Long) As Long

Private Declare Function SelectObject Lib "gdi32" _
(ByVal hDC As Long, ByVal hObject As Long) As Long

Private Declare Function DeleteObject Lib "gdi32" _
(ByVal hObject As Long) As Long

Private Declare Function CreateDCAsNull Lib "gdi32" Alias "CreateDCA" _
(ByVal lpDriverName As String, lpDeviceName As Any, _
lpOutput As Any, lpInitData As Any) As Long

Private Declare Function CreateDIBSection16 Lib "gdi32" Alias "CreateDIBSection" _
    (ByVal hDC As Long, _
    pBitmapInfo As BITMAPINFO16, _
    ByVal un As Long, _
    lplpVoid As Long, _
    ByVal handle As Long, _
    ByVal dw As Long) As Long
    
Private Declare Function CreateDIBSection256 Lib "gdi32" Alias "CreateDIBSection" _
    (ByVal hDC As Long, _
    pBitmapInfo As BITMAPINFO256, _
    ByVal un As Long, _
    lplpVoid As Long, _
    ByVal handle As Long, _
    ByVal dw As Long) As Long


Private Declare Function BitBlt Lib "gdi32" _
(ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, _
ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, _
ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long


' ***************  VarDeclarations for PBToGIF functions ****************
Private lpBits&, hMem&          ' Variabili per l' Image
Private bi As BITMAPINFO   ' del Picture Box.
Private BitsPerPixel&           ' Vedi sopra.
Private NCol&                   ' N. di colori in Tabella.
Private Code_Size&              ' "Code Size" [bits].
Private Code_Size1&             ' "Code Size + 1" corrente [bits].
Private NCode&                  ' N. Max corrente di Codici.
Private C_C&                    ' "Clear Code".
Private C_C1&                   ' "Clear Code + 1".
'
'Private Di_Ra() As String * 1   ' Dizionario delle Radici.
Private Type Sequenza_Type
    l As Long               ' Lunghezza della Sequenza.
    s As String             ' Stringa della Sequenza.
End Type
Private Di_Sq() As Sequenza_Type ' Dizionario delle Sequenze.
Private DSize_I&                ' Posizione e codice iniziale nel
                                ' Dizionario delle Sequenze.
Private DSize&                  ' Posizione corrente di scrittura e
                                ' prossimo codice, nel Dizionario
                                ' delle Sequenze.
Private Const MAXDSIZE& = 511   ' Posizione finale e codice Max.
                                ' del Dizionario delle Sequenze:
                                ' MAXDSIZE& = 2^x - 1 (x > BitsPerPixel).
                                ' Aumentandolo si riducono le dimensioni
                                ' del file GIF ma si aumenta il tempo di
                                ' elaborazione e l' uso di memoria.
'
Private BufCod$                 ' Buffer dei Codici.
Private BufDB(0 To 255) As Byte ' Buffer di uscita per la scrittura
                                ' dei "Data Blocks" e suo
Private iB&                     ' puntatore al byte da scrivere.
'
Private FG As Integer           ' # del File GIF temporaneo.
'
Private XBMP&                   ' Larghezza dell' Immagine BMP [bytes].
Private IW%                     ' Larghezza dell' Immagine [pixels].
Private IH%                     ' Altezza dell' Immagine [pixels].
Private SW%                     ' Larghezza dello Schermo [pixels].
Private SH%                     ' Altezza dello Schermo [pixels].
' *************** Declarations for PBToGIF functions *******************

Private Const MAX_PATH& = 260
Private Const GMEM_MOVEABLE = &H2

Private Const BI_RGB& = 0
Private Const DIB_RGB_COLORS& = 0
Private Const DIB_PAL_COLORS& = 1

' Our 2 PictureBoxes
Private PB1 As PictureBox
Private PB2 As PictureBox

' How many total stages to our function
Private m_StageTotal As Long
' How many units are we processing in this stage
Private m_linetotal As Long

' Private junk var for API calls
Private lngRet As Long
Private blRet As Long

' Must be module level vars
' to support creation of BITMAPINFO's of various Bit depths.
Private tBI16 As BITMAPINFO16, tBI256 As BITMAPINFO256




Public Function Save(ByRef Pic As PictureBox, _
      Optional ByRef PicConverted As PictureBox, _
      Optional ByVal sFileName As String, _
      Optional BitDepth As Long = 8) As Boolean
' This is our main function. It is passed a PictureBox control
' containing the Image we want to save as a Gif file.
' Optional a second PicureBox control is passed that is used
' as a status indicator to show the user where we
' are in the conversion process.
' Finally an optional filename can be passed that will be
' used to save the converted GIF file to.

' We need a cPalette object
Dim cPal As cPalette

' Local copy of a BITMAPINFOHEADER struct
Dim tBIH As BITMAPINFOHEADER

' We need a cDIBSection object
Dim cDIB As cDIBSection

' Create an instance of our cDIBSection
Set cDIB = New cDIBSection

' Set our primary PictureBox prop
' so that the object is visible throughout this module.
Set PB1 = Pic

On Error GoTo Err_Handler

If Not PicConverted Is Nothing Then
    ' Set our secondary PictureBox prop
    ' so that the object is visible throughout this module.
    Set PB2 = PicConverted
    ' Clear PictureBox
    PB2.Cls
    ' Refresh PictureBox
    PB2.Refresh
End If

' Set PictureBox Scalemode to pixels as all
' values related to dimensions will be expressed in pixels.
PB1.ScaleMode = vbPixels
' Create our DIBSection the same size as the PictureBox image
With PB1
    cDIB.Create PB1.ScaleX(.Picture.width), _
    PB1.ScaleY(.Picture.height)
End With

' If we were not passed a filename
' then popup the File Dialog window
If Len(sFileName & vbNullString) = 0 Then
    Dim FD As New cCommonDialog
    sFileName = FD.FileSaveGif
    Set FD = Nothing
End If
If Len(sFileName) & vbNullString = 0 Then
    Save = False
    Err.Raise vbObjectError + 525, "cDIBSectionSave.Save", "Cannot Create Printer DC"
End If

' Boundary checking for BitDepth value passed to us.
If BitDepth > 8 Then BitDepth = 8
If BitDepth < 2 Then BitDepth = 8
Select Case BitDepth
    Case 2, 3, 5, 6, 7
    BitDepth = 8
    
    Case Else
End Select

' We must create a new DIBSection of the correct colour depth to save.
Dim hdib As Long, lptr As Long, bSuccess As Boolean
Dim lHDC As Long, hBmpOld As Long, lHDCWOrk As Long, i As Long
Dim cDIBWork As cDIBSection
           
' Render the Image in the PictureBox to the DIBSection.
' We cannot just BLIT from the PictureBox's hDC as the
' entire Image may not be visible. The render method also handles
' Metafiles transparently for us.
With PB1
    .Picture.Render cDIB.hDC, 0, 0, cDIB.width, cDIB.height, _
    0, .Picture.height, .Picture.width, -.Picture.height, 0&
End With
           
 ' Create optimal palette using octree quantisation:
 Set cPal = New cPalette
 
 ' Create the optimal palette for our DIBSection
 ' using the Octree algorithm.
 cPal.CreateOptimal cDIB, Me, 2 ^ BitDepth
 
 ' Create a temp working DIBSection
 Set cDIBWork = New cDIBSection
 cDIBWork.Create cDIB.width, cDIB.height
 
 ' Apply the palette we generated.
 cPal.ApplyPalette cDIB, cDIBWork, Me
                    
' Create our output DIB section (with appropriate palette):
Select Case BitDepth
  
Case 4 ' 16 colors
   pbCreate16ColourDIBSection hdib, tBI16, lptr, cDIB.width, cDIB.height, cPal

Case 8  ' 256 colors
pbCreate256ColourDIBSection hdib, tBI256, lptr, cDIB.width, cDIB.height, cPal

Case Else
pbCreate256ColourDIBSection hdib, tBI256, lptr, cDIB.width, cDIB.height, cPal
End Select


' Do we have a valid handle to a DIBSection
If hdib = 0 Then
    Save = False
    Err.Raise vbObjectError + 526, "cDIBSectionSave.Save", "Cannot Create DIBSection"
End If


' Blit the appropriate true colour DIB into our DIB:
' First create a temp Display DC
lHDC = CreateDCAsNull("DISPLAY", ByVal 0&, ByVal 0&, ByVal 0&)
If lHDC = 0 Then
    Save = False
    Err.Raise vbObjectError + 527, "cDIBSectionSave.Save", "Cannot Create Display DC"
End If

' Create a temp compatible DC
lHDCWOrk = CreateCompatibleDC(lHDC)
If lHDCWOrk = 0 Then
    Save = False
    Err.Raise vbObjectError + 528, "cDIBSectionSave.Save", "Cannot Create Compatible DC"
End If

' Delete our temp Display DC
DeleteDC lHDC

' Select our DIBSection into our temp DC
hBmpOld = SelectObject(lHDCWOrk, hdib)
If hBmpOld = 0 Then
    Save = False
    Err.Raise vbObjectError + 529, "cDIBSectionSave.Save", "Cannot Select DIBSection into DC"
End If

' Paint our original DIBSection into our working color reduced DIBSection
cDIB.PaintPicture lHDCWOrk
 
' Convert our DIB to a disk based Gif file
' Clear the error object first
Err.Clear
lngRet = 0
lngRet = PictureBoxToGif(hdib, PB1, sFileName, cDIB, , BitDepth)
If lngRet <> 0 Then
    Save = False
    Err.Raise vbObjectError + 530, "cDIBSectionSave.Save", "PictureBoxToGif function failed"
End If


' Were we passed a second PictureBox control
If Not PB2 Is Nothing Then
    ' Copy our color reduced DIB into our second PictureBox.
    ' Clear the control first.
    PB2.Cls
    lngRet = 0
    lngRet = BitBlt(PB2.hDC, 0, 0, cDIB.width, _
    cDIB.height, lHDCWOrk, 0, 0, vbSrcCopy)
    If lngRet = 0 Then
    Save = False
    Err.Raise vbObjectError + 531, "cDIBSectionSave.Save", "Blit to our status PictureBox failed"
End If
    ' Refresh our status PictureBox
    PB2.Refresh
End If


' Clean up.
If lHDCWOrk <> 0 Then
    SelectObject lHDCWOrk, hBmpOld
    DeleteDC lHDCWOrk
    DeleteObject hdib
End If
     
 ' Exit normally
Exit_OK:
Exit Function

Err_Handler:
Err.Raise Err.Source, Err.Number, Err.Description
Resume Exit_OK
     
End Function


Private Function pbCreate16ColourDIBSection(ByRef hdib As Long, _
ByRef tbi As BITMAPINFO16, ByRef lptr As Long, ByVal lWidth As Long, _
ByVal lheight As Long, Optional ByRef cP As cPalette = Nothing) As Boolean

Dim lScanSize As Long
Dim lHDC As Long
Dim i As Long
Dim iMax As Long

   lHDC = CreateDCAsNull("DISPLAY", ByVal 0&, ByVal 0&, ByVal 0&)
   With tbi.bmiHeader
       .biSize = Len(tbi.bmiHeader)
       .biWidth = lWidth
       .biHeight = lheight
       .biPlanes = 1
       .biBitCount = 4
       .biCompression = BI_RGB
       lScanSize = lWidth \ 2
       lScanSize = lScanSize + lScanSize Mod 4
       .biSizeImage = lScanSize * .biHeight
   End With
   

iMax = 15
   If iMax >= cP.Count Then
      iMax = cP.Count - 1
   End If
   For i = 0 To iMax
      With tbi.bmiColors(i)
         .rgbBlue = cP.Blue(i + 1)
         .rgbGreen = cP.Green(i + 1)
         .rgbRed = cP.Red(i + 1)
      End With
   Next

   hdib = CreateDIBSection16( _
           lHDC, _
           tbi, _
           DIB_RGB_COLORS, _
           lptr, _
           0, 0)
   pbCreate16ColourDIBSection = (hdib <> 0)
   DeleteDC lHDC
End Function

Private Function pbCreate256ColourDIBSection(ByRef hdib As Long, ByRef tbi As BITMAPINFO256, _
ByRef lptr As Long, ByVal lWidth As Long, ByVal lheight As Long, _
Optional ByRef cP As cPalette = Nothing) As Boolean


Dim lScanSize As Long
Dim lHDC As Long
Dim i As Long
Dim iMax As Long
   lHDC = CreateDCAsNull("DISPLAY", ByVal 0&, ByVal 0&, ByVal 0&)
   With tbi.bmiHeader
       .biSize = Len(tbi.bmiHeader)
       .biWidth = lWidth
       .biHeight = lheight
       .biPlanes = 1
       .biBitCount = 8
       .biCompression = BI_RGB
       lScanSize = (lWidth + lWidth Mod 4)
       .biSizeImage = lScanSize * .biHeight
   End With
   
   iMax = 255
   If iMax >= cP.Count Then
      iMax = cP.Count - 1
   End If
   For i = 0 To iMax
      With tbi.bmiColors(i)
         .rgbBlue = cP.Blue(i + 1)
         .rgbGreen = cP.Green(i + 1)
         .rgbRed = cP.Red(i + 1)
      End With
   Next
   hdib = CreateDIBSection256( _
           lHDC, _
           tbi, _
           DIB_RGB_COLORS, _
           lptr, _
           0, 0)
   pbCreate256ColourDIBSection = (hdib <> 0)
   DeleteDC lHDC
End Function
      
      


'=====================================================
' Descrizione.....: PictureBox.Picture -> File GIF
' Nome dei Files..: PB2Gif.bas, InfoPr.frm, InfoPr.frx
' Data............: 17/9/1999
' Versione........: 2.0 a 32 bits
' Sistema.........: Visual Basic 6.0
'                   sotto Windows NT 4.0 (SP 3).
' Scritto da......: F. Languasco 
' E-Mail..........: MC7061@mclink.it
'=====================================================
'
'   PB2Gif.bas: Programma per salvare l' Image di
'   un PictureBox su file GIF.
'   Da usare insieme a frmInfoPr (InfoPr.frm).
'
'   Function:
'     PictureBoxToGif Src, File_GIF$, [BackTras As Boolean] _
'     , [BitsPerPixel&], [Interlaced As Boolean], [TCol] _
'     , [MSin&], [MSup&], [NCln&], [NRig&], [LCln&], [ARig&] _
'     , [BCol&], [FCol&], [PText$]
'
'   Src:           Picture Box di cui si vuole salvare l' Image su
'   File_GIF$:     File, completo di path [e con estensione .gif].
'   BackTras:      Blocca l' immagine di Src come BackGround BitMap.
'                  Per Windows NT:
'                  True  -> copia sul file GIF anche i grafici generati
'                           al "Run Time" con i metodi Line, Circle,
'                           Print, etc.. (default).
'                  False -> copia sul file GIF solo l' Image di
'                           BackGround.
'                  Per Windows 98: deve essere sempre True (default).
'   BitsPerPixel&: N. di [bits per pixel]. Opzionale e puo' essere solo:
'                  1 -> l' immagine viene salvata in Bianco e Nero.
'                  4 -> l' immagine viene salvata a 16 colori.
'                  8 -> l' immagine viene salvata a 256 colori (default).
'   Interlaced:    Ordine delle righe. Opzionale:
'                  False -> ordine sequenziale (default).
'                  True  -> ordine inter-allacciato. Permette, durante
'                           un caricamento lento (e.g. pagine Web), di
'                           vedere il contenuto generale dell' immagine
'                           prima che tutti i dati siano stati
'                           elaborati/trasmessi.
'   TCol:          Colore che si vuole rendere trasparente.
'
'                  Parametri del "Plain Text Extension":
'   MSin&, MSup&:  Margini sinistro e superiore [pixels].
'   NCln&, NRig&:  Numero di colonne e di righe.
'   LCln&, ARig&:  Larghezza ed altezza di colonne e di righe [pixels].
'   BCol&, FCol&:  BackColor e ForeColor del testo.
'   PText$:        Testo da inserire sull' immagine.
'
'   La funzione ritorna True se il trasferimento e' stato completato
'   con successo, altrimenti ritorna False.
'
'   Note:
'   (1) E' stata riportata, a solo scopo illustrativo e non
'       utilizzata, la struttura standard di compressione LZW con
'       doppio dizionario (delle radici e delle sequenze): in effetti,
'       l' uso di variabili di tipo String, permette di semplificare
'       l' algoritmo e di usare un solo dizionario (delle sequenze).
'       Il dizionario delle sequenze e' stato definito come struttura
'       di una String e della sua lunghezza: in questo modo diventa,
'       mediamente, piu' veloce la ricerca del N. di codice associato
'       ad una certa sequenza (nella routine Code).
'   (2) Il blocco "Plain Text Extension", previsto dallo standard
'       GIF89a, e' tuttora gestito da pochissimi decoders.
'       Attualmente, della decina e piu' che ho provato (VisualBasic 6.0,
'       Netscape, Internet Explorer, Photo Shop, etc...), solo due
'       (VesaView e FreeLance) hanno saputo riconoscerlo ed anche con
'       qualche limitazione.  L' ho comunque incluso per completezza.
'   (3) Del blocco "Graphic Control Extension"  ho utilizzato solo
'       i controlli di Colore Trasparente.  Le altre opzioni servono,
'       essenzialmente, per files GIF con immagini multiple.
'   (4) "The Graphics Interchange Format(c) is the Copyright property
'       of CompuServe Incorporated. GIF(sm) is a Service Mark property
'       of CompuServe Incorporated."
'   (5) L' algoritmo di compressione LZW e' brevettato da Unisys.
'       L' Unisys attualmente richiede che chiunque usi questo
'       algoritmo, per scopi commerciali, sia in possesso di una
'       loro licenza.
'
'       Per maggiori informazioni fare riferimento al file Gif89m.txt.
Public Function PictureBoxToGif(hdib As Long, ByVal Src As PictureBox, _
ByVal File_GIF$, ByRef cDIB As cDIBSection _
     , Optional ByVal BackTras As Boolean = True _
     , Optional ByVal BxP& = 8 _
     , Optional ByVal Interlaced As Boolean = False _
     , Optional ByVal TCol As Variant _
     , Optional ByVal MSin& = 0, Optional ByVal MSup& = 0 _
     , Optional ByVal NCln& = 0, Optional ByVal NRig& = 0 _
     , Optional ByVal LCln& = 8, Optional ByVal ARig& = 16 _
     , Optional ByVal BCol& = vbWhite, Optional ByVal FCol& = vbBlack _
     , Optional ByVal PText$ = "") As Boolean



    Dim i&, ILZW&, XIP&, YIP&, ByI&, ByC&, PixN&
    Dim ByteAddr&, InBuf As Byte, ScanRows&()
    Dim c$, a&, r1&, FileN$, FileGifTemp$
    Dim Passi&, CBin$, Ps&, p&
    'Dim PalT&(0 To 255), TotPix&   ' Vettore per determinare la
                                    ' frequenza dei colori.

    On Error GoTo PictureBoxToGif_ERR

    'frmInfoPr.Apri File_GIF$, "Salva PictureBox -> File GIF", vbNormal

    If BackTras Then
        ' Blocca l' immagine di Src come Background BitMap.
        ' Funziona anche con scheda video impostata a
        ' profondita' di colore = 8 [bits per pixel]:
        FileN$ = TempFile$
        'SavePicture Src.Image, FileN$
        'Src.Picture = LoadPicture("")
        'Src.Picture = LoadPicture(FileN$)
        If FileExists(FileN$) Then Kill FileN$
    End If

    BitsPerPixel = BxP
    Passi = Switch(BitsPerPixel = 1, 8, BitsPerPixel = 4, 2 _
    , BitsPerPixel = 8, 1)

    If Not Legge_PictureBox(Src, hdib) Then Err.Raise vbObjectError + 1
    
    
    
    If Not Legge_BMP(MSin + NCln * LCln _
    , MSup + NRig * ARig) Then Err.Raise vbObjectError + 1
'
    ' If we were passed a filename use or
    ' then we must generate one.

    If Len(File_GIF$) & vbNullString = 0 Then
        File_GIF$ = TempFile$("GIF")
    End If
        
    
      FG = FreeFile
    Open File_GIF$ For Binary As #FG

    Code_Size = IIf(BitsPerPixel = 1, 2, BitsPerPixel)
    Code_Size1 = Code_Size + 1  ' "Code Size + 1" [Bits].
    NCode = 2 ^ Code_Size1      ' N. Max corrente di Codici.
    C_C = 2 ^ Code_Size         ' Codice "Clear Code".
    C_C1 = C_C + 1              ' Codice "Clear Code + 1".
    DSize_I = C_C + 2           ' Posizione iniziale del Dizionario.
    DSize = DSize_I             ' Posizione corrente nel Dizionario.

    BufCod$ = ""                ' Azzera il Buffer dei codici
    iB = 0                      ' ed il puntatore nel Buffer dei
                                ' "Data Blocks". Necessario nel caso
                                ' che una precedente esecuzione sia
                                ' stata terminata prematuramente.

    'ReDim Di_Ra(0 To NCol - 1)     ' Dizionario delle Radici.
    'For I = 0 To NCol - 1          '
    '    Di_Ra(I) = Chr$(I)         '
    'Next I                         '

    ReDim Di_Sq(DSize To MAXDSIZE)  ' Dizionario delle Sequenze.

    ' Prepara il vettore dell' ordine delle righe:
    Ord_ScanRows ScanRows(), Interlaced

    Scrivi_Int                  ' Scrive sul File l' intestazione
                                ' del GIF ("Header" + "Logical
                                ' Screen Descriptor").
    Scrivi_GCT                  ' Scrive sul File la "Global
                                ' Color Table".
    If Not IsMissing(TCol) Then ' Scrive il "Graphic Control
        Scrivi_GCE (TCol)       ' Extension".
    End If
    Scrivi_ImD 0, 0, Interlaced ' Scrive sul File l' "Image Descriptor"
                                ' ed il "Code Size".

'   Inizia la Compressione:
    ILZW = 1                    ' N. di chiamata dell' algoritmo LZW.
    OutB C_C                    ' Inizia il Blocco Dati Compressi
                                ' (facoltativo ma consigliato).

    ' Update our status display prop
    LineTotal = IH

    For YIP = 1 To IH
    UpdateStatus YIP, cDIB.width, cDIB.height, "Saving Gif file", 3
   
        ByI = ScanRows(YIP) * XBMP + lpBits ' Byte d' inizio della
                                            ' riga corrente.
        ByC = 0                             ' Byte corrente nella riga.
        Ps = 0                              ' Passo corrente nel Byte.
        For XIP = 1 To IW
            If Ps = 0 Then
                ByteAddr = ByI + ByC
                CopyMemory InBuf, ByVal ByteAddr, 1
                CBin$ = Dec2Bin$(InBuf, 8)
                Ps = Passi
                ByC = ByC + 1
            End If

            p = 9 - BitsPerPixel * Ps
            c$ = Chr$(Bin2Dec(Mid$(CBin$, p, BitsPerPixel), BitsPerPixel))

            'PalT(Asc(C$)) = PalT(Asc(C$)) + 1

            a = LZWEncode(c$, ILZW)
            If a >= 0 Then
                OutB a
            End If
            ILZW = ILZW + 1

            If DSize >= MAXDSIZE Then
                a = LZWEncode("", -1) ' Termina il Processo corrente
                OutB a                ' di Compressione.
                OutB C_C              ' Re-Inizia il Blocco Dati Compressi.
                Canc_DiS              ' Azzera il Dizionario delle Sequenze.
                ILZW = 1
            End If

            Ps = Ps - 1
        Next XIP

        DoEvents
        'If frmInfoPr.Termina Then Err.Raise 18
        'frmInfoPr.Info CSng(YIP) / CSng(IH) ' Informa sulla percentuale
                                            ' di lavoro fatto.
    Next YIP


    a = LZWEncode("", -1)   ' Termina il Processo di
    OutB a                  ' Compressione.
    OutB C_C1               ' Codice "Clear Code + 1": termina il
                            ' "Data Stream".
    Scrivi_CEx Src.Name     ' Scrive la "Comment Extension".
    If PText$ <> "" Then    ' Scrive, sull' immagine, il "Plain Text".
        Scrivi_PTE MSin, MSup _
        , NCln, NRig, LCln, ARig _
        , BCol, FCol, PText$
    End If
    Scrivi_GTr              ' Scrive sul File il codice di "GIF
                            ' Trailer".

    Close #FG: FG = 0       ' Chiude il File per poterlo copiare.
    'FileCopy FileGifTemp$, File_GIF$  ' Salva sul File richiesto.

    ' Stampa la tabella dei colori e
    ' le sue frequenze nell' immagine:
    'For I = 0 To NCol - 1
    '    Debug.Print "Ci: "; I, _
    '    "Blu: "; bi.bmiColors(I).rgbBlue, _
    '    "Verde: "; bi.bmiColors(I).rgbGreen, _
    '    "Rosso: "; bi.bmiColors(I).rgbRed, _
    '    "Freq: "; PalT(I)
    '    TotPix = TotPix + PalT(I)
    'Next I
    'Debug.Print "Pixels nell' immagine: "; TotPix


PictureBoxToGif_ERR:
    PictureBoxToGif = Err.Number

    If FG <> 0 Then Close #FG
    'If FileExists(FileGifTemp$) Then Kill FileGifTemp$
    If hMem <> 0 Then
        r1 = GlobalUnlock(hMem)
        hMem = GlobalFree(hMem)
    End If
    'Unload frmInfoPr



End Function



Private Function Ceil(ByVal x As Double) As Double

'   Funzione di arrotondamento, per numeri reali,
'   all' intero uguale o immediatamente superiore:
'
    If x = Int(x) Then
        Ceil = x
    ElseIf x > 0# Then
        Ceil = Int(x) + 1#
    ElseIf x < 0# Then
        Ceil = Fix(x)
    End If

End Function

Private Function Legge_PictureBox(ByVal PBSrc As PictureBox, ByVal hdib As Long) As Boolean
' **************
' I do not need PBSrc any more
' *************

    'Dim hDC_PB&, hDC_Mem&, BytesNeeded&
    Dim BytesNeeded&
    Dim r1&, PB_Width&, PB_Height&   ', RC As RECT

    On Error GoTo Legge_PictureBox_ERR
    
    
    Dim lngRet As Long
    Dim ds As DIBSECTION
        
 
    ' Fill in our DIBSECTION structure
    lngRet = apiGetObject(hdib, Len(ds), ds)

    ' Create a temporary memory DC and select into it
    ' the background picture of the PBSrc Picture Box:
    'hDC_PB = GetWindowDC(0&) 'PBSrc.hwnd)
    'hDC_Mem = CreateCompatibleDC(hDC_PB)

    'r1 = GetClientRect(PBSrc.hwnd, RC)
    PB_Width = ds.dsBm.bmWidth
    PB_Height = ds.dsBm.bmHeight
    

    ' Fill the BITMAPINFO for the desired DIB:
    bi.BITMAPINFOHEADER.biSize = Len(bi.BITMAPINFOHEADER)
    bi.BITMAPINFOHEADER.biWidth = PB_Width
    bi.BITMAPINFOHEADER.biHeight = PB_Height
    bi.BITMAPINFOHEADER.biPlanes = 1    'ColorPlanes
    bi.BITMAPINFOHEADER.biBitCount = BitsPerPixel
    bi.BITMAPINFOHEADER.biCompression = BI_RGB

    ' Calculate the number of bytes needed to store the image:
    'BytesNeeded = ScanAlign(PB_Width * BitsPerPixel / 8) * PB_Height
    ' Franco the above routine was failing at a width of 369 pixels
    ' and a Bitsperpixel value of 4.
    BytesNeeded = ds.dsBmih.biSizeImage


    ' Allocate a buffer to hold the bitmap bits:
    hMem = GlobalAlloc(GMEM_MOVEABLE, BytesNeeded)

    If hMem <> 0 Then
        lpBits = GlobalLock(hMem)
        
        
        ' Copy the DIB bits into the Memory
        ' pointed to by our lpBits var.
       CopyMemory ByVal lpBits, ByVal ds.dsBm.bmBits, ds.dsBmih.biSizeImage
       ' now copy over the ColorTable
         Dim x As Long
                
        ' Use proper color table
        If BitsPerPixel = 8 Then
            For x = 0 To 255
                bi.bmiColors(x).rgbBlue = tBI256.bmiColors(x).rgbBlue
                bi.bmiColors(x).rgbGreen = tBI256.bmiColors(x).rgbGreen
                bi.bmiColors(x).rgbRed = tBI256.bmiColors(x).rgbRed
                bi.bmiColors(x).rgbReserved = tBI256.bmiColors(x).rgbReserved
            Next x
        Else
            For x = 0 To 15
                bi.bmiColors(x).rgbBlue = tBI16.bmiColors(x).rgbBlue
                bi.bmiColors(x).rgbGreen = tBI16.bmiColors(x).rgbGreen
                bi.bmiColors(x).rgbRed = tBI16.bmiColors(x).rgbRed
                bi.bmiColors(x).rgbReserved = tBI16.bmiColors(x).rgbReserved
            Next x
        
        End If
        
    Else
        Err.Raise vbObjectError + 3
    End If

Legge_PictureBox_ERR:
    Legge_PictureBox = (Err = 0)
    'r1 = DeleteDC(hDC_Mem)
End Function

Private Function TempFile$(Optional ByVal I3C$ = "TMP" _
    , Optional ByRef TempPath As String)
'
'   Ritorna il Nome di un File temporaneo [da cancellare
'   esplicitamente dopo l' uso].
'   Con I3C$ si possono specificare fino a tre caratteri
'   iniziali per l' identificazione del file:
'
    Dim r1&, lpBuffer$
    Dim TempFileName As String

    r1 = GetTempPath(0, "")
    lpBuffer$ = Space(r1)
    r1 = GetTempPath(r1, lpBuffer$)
    TempPath = Left$(lpBuffer$, r1)

    TempFileName = Space(MAX_PATH)
    r1 = GetTempFileName(TempPath, I3C$, 0, TempFileName)
    TempFile$ = Trim$(TempFileName)

End Function

Private Function ScanAlign(ByVal pwidth As Long) As Long
'
'   Ritorna un multiplo di 4 uguale o immediatamente
'   superiore a pwidth&:
'
    ScanAlign = (pwidth + 3) And &HFFFFFFFC

End Function
Private Sub Agg_DiS(ByVal a$)
'
'   Inserisce la stringa A$ nel dizionario delle Sequenze.

    Dim l&, i&

    l = Len(a$)
    If l > 1 Then
        Di_Sq(DSize).l = l
        Di_Sq(DSize).s = a$
        DSize = DSize + 1

        If DSize > NCode + 1 Then
            Code_Size1 = Code_Size1 + 1
            NCode = 2 ^ Code_Size1
        End If
    End If

End Sub

Private Function Dec2Bin$(ByVal ND&, ByVal l&)
'
'   Converte il n. decimale positivo ND& in stringa binaria di L& [bits].
'   (0 <= ND& <= 2147483647, L& < 32).
'   Deve essere ND& < 2 ^ L&: nessun controllo viene effettuato.
'   Volendo si puo' calcolare la lunghezza minima L& con la formula:
'     L = CLng(Ceil(Log(ND + 1) / Log(2))) ' con 0 < ND < 2147483647.
'
    Dim SB$, d&, i&

    SB$ = ""
    d = 2 ^ (l - 1)
    For i = 1 To l
        If ND - d >= 0 Then
            SB$ = SB$ & "1"
            ND = ND - d
        Else
            SB$ = SB$ & "0"
        End If
        d = d / 2
    Next i

    Dec2Bin$ = SB$

End Function

Private Sub Canc_DiS()
'
'   Re-Inizia il Dizionario delle Sequenze:
'
    Code_Size1 = Code_Size + 1
    NCode = 2 ^ Code_Size1
    DSize = DSize_I
    ReDim Di_Sq(DSize_I To MAXDSIZE) 'As Dictionary

End Sub

Private Function Code(ByVal a$) As Long
'
'   Cerca la stringa A$ (radice o sequenza) nei dizionari e ne
'   ritorna il N. di Codice.
'   Ritorna -1 se la stringa A$ non e' trovata:

    Dim l&, i&

    l = Len(a$)
    If l = 1 Then   ' Cerca nel dizionario delle Radici:
        'For I = 0 To NCol - 1
        '    If A$ = Di_Ra(I) Then
        '        Code = I
        '        Exit Function
        '    End If
        'Next I
        Code = Asc(a$)
        Exit Function
    Else            ' Cerca nel dizionario delle Sequenze:
        For i = DSize_I To DSize - 1
            If Di_Sq(i).l = l Then
                If a$ = Di_Sq(i).s Then
                    Code = i
                    Exit Function
                End If
            End If
        Next i
    End If

    Code = -1  ' La stringa A$ non e' presente nei dizionari.

End Function

Private Function Bin2Dec(ByVal SB$, ByVal l&) As Long
'
'   Converte gli L& [bits] piu' significativi della stringa
'   binaria SB$ in n. decimale positivo (L& < 32):
'
    Dim d&, V&, i&

    d = 0
    V = 2 ^ (l - 1)
    For i = 1 To l
        If Mid$(SB$, i, 1) = "1" Then
            d = d + V
        End If
        V = V / 2
    Next i

    Bin2Dec = d

End Function

Private Function FileExists(ByVal path$) As Boolean
'
'----------------------------------------------------------
' Check for the existence of a file by attempting an OPEN.
'----------------------------------------------------------
'
    Dim FF%

    On Error Resume Next

    FF = FreeFile

    Open path$ For Input As FF
    FileExists = (Err = 0)
    Close FF

End Function


Private Function Legge_BMP(ByVal WPText&, ByVal HPText&) As Boolean
'

    On Error GoTo Legge_BMP_ERR '
    ' Legge i Parametri del DIB:
    IW = CInt(bi.BITMAPINFOHEADER.biWidth)
    IH = CInt(bi.BITMAPINFOHEADER.biHeight)
    XBMP = ScanAlign(IW * BitsPerPixel / 8) ' La XBMP& deve essere
                                            ' un multiplo di 4.
    NCol = 2 ^ BitsPerPixel

    SW = IW     ' Screen Width >= Image Width.
    If SW < WPText Then SW = WPText
    SH = IH     ' Screen Height >= Image Height.
    If SH < HPText Then SH = HPText


Legge_BMP_ERR:
    Legge_BMP = (Err = 0)


End Function

Private Function LZWEncode(ByVal c$, ByVal ILZW&) As Long
'
'   Compressione LZW:
'
    Static w$

    If ILZW = 1 Then
        w$ = c$
        'Agg_DiS W$  ' E' sempre una radice.
        LZWEncode = -1

    ElseIf ILZW = -1 Then
        LZWEncode = Code(w$)

    Else
        If Code(w$ & c$) >= 0 Then
            w$ = w$ & c$
            LZWEncode = -1
        Else
            LZWEncode = Code(w$)
            Agg_DiS w$ & c$
            w$ = c$
        End If
    End If

End Function

Private Sub OutB(ByVal c&)
'
'   Formatta i Codici in lunghezza Code_Size1& [bits]
'   ed emette un Byte per volta:
'
    Dim SB$, b&

    SB$ = Dec2Bin$(c, Code_Size1)
    BufCod$ = SB$ & BufCod$
    Do While Len(BufCod$) >= 8
        b = Bin2Dec(Right$(BufCod$, 8), 8)
        PacB b
        BufCod$ = Left$(BufCod$, Len(BufCod$) - 8)
    Loop

    If c = C_C1 Then    ' Termina la scrittura del "Data Stream":
        b = Bin2Dec(BufCod$, Len(BufCod$))
        PacB b
        PacB -1
        'BufCod$ = ""   ' Viene azzerato all' inizio. Da rivedere
                        ' all' estensione del programma per immagini
                        ' multiple.
    End If

End Sub

Private Sub PacB(ByVal b&)
'
'   Compone i bytes di uscita in pacchetti di 255 [Bytes]
'   e li scrive sul file FileGifTemp$:
'
    Dim i&

    If b >= 0 Then
        iB = iB + 1
        BufDB(iB) = CByte(b)
        If iB = 255 Then
            GoSub ScriviPac
        End If
    Else
        ' Emette, se e' il caso, l' ultimo
        ' pacchetto > 0 e <= di 255 [Bytes]:
        If iB > 0 Then GoSub ScriviPac
        ' Scrive il "Block Terminator":
        GoSub ScriviPac
    End If
    Exit Sub


ScriviPac:      ' Scrive i pacchetti sul File:
    BufDB(0) = CByte(iB)
    For i = 0 To iB
        Put #FG, , BufDB(i)
    Next i
    iB = 0
    Return

End Sub

Private Sub Scrivi_GTr()
'
'   Scrive sul File la parte terminale del Gif:
'
    Dim b As Byte
'
    b = &H3B        ' ";"
    Put #FG, , b    ' -> "GIF Trailer".

End Sub

Private Sub Scrivi_ImD(ByVal IL%, ByVal IT% _
    , ByVal Interlaced As Boolean)
'
'   Scrive sul File la parte descrittiva del Gif:
'   IL% = Image Left.
'   IT% = Image Top.
'   IW% = Image Width.
'   IH% = Image Height.
'
    Dim b As Byte

    b = &H2C            ' "," ->
    Put #FG, , b        ' "Image separator character".

    Put #FG, , IL
    Put #FG, , IT
    Put #FG, , IW
    Put #FG, , IH

    If Interlaced Then
        b = &H40        ' "|0|1|0|00|xxx|" -> |M|I|S|RR|pixel|
    Else
        b = &H0         ' "|0|0|0|00|xxx|" -> |M|I|S|RR|pixel|
    End If
    'B = B Or CByte(BitsPerPixel - 1)   ' Non necessario, mancando
                                        ' la "Local Color Table".
    Put #FG, , b        ' -> "Packed Fields".

    ' Questo byte, formalmente, non appartiene all' "Image Descriptor"
    ' ma al "Raster Data Stream". Viene scritto qui per semplificare
    ' le routines che seguono:
    b = CByte(Code_Size)
    Put #FG, , b

End Sub

Private Sub Scrivi_Int()
'
'   Scrive sul File la parte iniziale del Gif:
'   SW% = Screen Width.
'   SH% = Screen Height.
'
    Dim a$, b As Byte

    ' "Header":
    a$ = "GIF89a"
    Put #FG, 1, a$

    ' "Logical Screen Descriptor":
    Put #FG, , SW
    Put #FG, , SH

    b = &HF0        ' "|1|111|0|xxx|" -> |M|cr|S|pixel|
    b = b Or CByte(BitsPerPixel - 1)
    Put #FG, , b    ' -> "Packed Fields"

    b = &H0         ' "Background Color Index".
    Put #FG, , b

    b = &H0         ' "Pixel Aspect Ratio".
    Put #FG, , b

End Sub

Private Sub Scrivi_GCT()
'
'   Scrive sul File la tabella globale dei colori:
'
    Dim c&

    For c = 0 To NCol - 1
        Put #FG, , bi.bmiColors(c).rgbRed
        Put #FG, , bi.bmiColors(c).rgbGreen
        Put #FG, , bi.bmiColors(c).rgbBlue
    Next c

End Sub



Private Sub Scrivi_CEx(ByVal PicBoxName$)
'
'   Scrive il "Comment Extension":
'
    Dim m$, c&, b As Byte

    b = &H21        ' "!"
    Put #FG, , b    ' -> "Extension Introducer".

    b = &HFE        ' "Extension Function Code"
    Put #FG, , b    ' -> "Comment Label".

    m$ = PicBoxName$ & " "
    m$ = m$ & "F. Languasco - CopyRight 1999"

    For c = 1 To Len(m$)
        b = AscB(Mid$(m$, c, 1))
        PacB b
    Next c
    PacB -1

End Sub

Private Sub Ord_ScanRows(ScanRows&(), ByVal Interlaced As Boolean)
'
'   Prepara il vettore ScanRows&() contenente l' ordine delle
'   righe dell' Immagine da copiare sul GIF.
'   L' ordine viene anche invertito, perche' il BMP usa le
'   righe dal basso all' alto ed il GIF dall' alto al basso.
'
    Dim y&, Passo&, Riga&
    ReDim ScanRows(1 To IH)

    If Interlaced Then      ' GIF in ordine inter_allacciato:
        y = 0
        For Passo = 1 To 4
            Select Case Passo
                Case 1
                For Riga = 1 To IH Step 8
                    y = y + 1
                    ScanRows(y) = IH - Riga
                Next Riga

                Case 2
                For Riga = 5 To IH Step 8
                    y = y + 1
                    ScanRows(y) = IH - Riga
                Next Riga

                Case 3
                For Riga = 3 To IH Step 4
                    y = y + 1
                    ScanRows(y) = IH - Riga
                Next Riga

                Case 4
                For Riga = 2 To IH Step 2
                    y = y + 1
                    ScanRows(y) = IH - Riga
                 Next Riga
            End Select
        Next Passo

    Else                    ' GIF in ordine sequenziale:
        For y = 1 To IH
            ScanRows(y) = IH - y
        Next y
    End If

End Sub

Private Sub Scrivi_PTE(ByVal MSin&, ByVal MSup& _
    , ByVal NCln&, ByVal NRig&, ByVal LCln&, ByVal ARig& _
    , ByVal BCol&, ByVal FCol&, ByVal PText$)
'
'   Scrive il "Plain Text Extension":
'
    Dim m$, c&, i As Integer, b As Byte

    b = &H21                ' "!"
    Put #FG, , b            ' -> "Extension Introducer".

    b = &H1                 ' "Extension Function Code"
    Put #FG, , b            ' -> "Plain Text Label".

    b = 12                  ' "Block Size" sempre di 12 [bytes].
    Put #FG, , b

    i = MSin                ' "Text Grid Left Position"
    Put #FG, , i

    i = MSup                ' "Text Grid Top Position"
    Put #FG, , i

    i = NCln * LCln         ' "Text Grid Width"
    Put #FG, , i

    i = NRig * ARig         ' "Text Grid Height"
    Put #FG, , i

    b = LCln                ' "Character Cell Width"
    Put #FG, , b

    b = ARig                ' "Character Cell Height"
    Put #FG, , b

    b = Cerca_Col(FCol)     ' "Text Foreground Color Index"
    Put #FG, , b

    b = Cerca_Col(BCol)     ' "Text Background Color Index"
    Put #FG, , b

    For c = 1 To Len(PText$)
        b = AscB(Mid$(PText$, c, 1))
        PacB b
    Next c
    PacB -1

End Sub

Private Sub Scrivi_GCE(ByVal TCol&)
'
'   Scrive il "Graphic Control Extension":
'
    Dim i As Integer, b As Byte

    b = &H21                ' "!"
    Put #FG, , b            ' -> "Extension Introducer".

    b = &HF9                ' "Extension Function Code"
    Put #FG, , b            ' -> "Graphic Control Label".

    b = 4                   ' "Block Size" sempre di 4 [bytes].
    Put #FG, , b

    b = &H5                 ' "|000|001|0|1|" -> "|RRR|DDD|U|T|"
    Put #FG, , b            ' -> "Packed Fields".

    i = 0                   ' "Delay Time".
    Put #FG, , i

    b = Cerca_Col(TCol&)    ' "Transparent Color Index".
    Put #FG, , b

    b = 0                   ' "Block Terminator".
    Put #FG, , b

End Sub

Private Function Cerca_Col(ByVal VCol&) As Byte
'
'   Cerca, nella tabella dei colori, il colore che piu'
'   si avvicina a VCol e ne ritorna l' indice:
'
    Dim r&, g&, b&, c&, CC&, DQ&, DisQ&

    r = VCol And &HFF           ' Componente Rossa.
    g = (VCol \ &H100) And &HFF ' Componente Verde.
    b = VCol \ &H10000          ' Componente Blu.

    DisQ = 10000000
    For c = 0 To NCol - 1
        DQ = (r - CLng(bi.bmiColors(c).rgbRed)) ^ 2
        DQ = DQ + (g - CLng(bi.bmiColors(c).rgbGreen)) ^ 2
        DQ = DQ + (b - CLng(bi.bmiColors(c).rgbBlue)) ^ 2
        If DisQ > DQ Then
            CC = c
            DisQ = DQ
        End If
    Next c

    Cerca_Col = CByte(CC)

End Function


Public Property Let StageTotal(x As Long)
m_StageTotal = x
End Property

Public Property Get StageTotal() As Long
StageTotal = m_StageTotal
End Property

Public Property Let LineTotal(x As Long)
m_linetotal = x
End Property

Public Property Get LineTotal() As Long
LineTotal = m_linetotal
End Property

' ElCheapo Progress meter
Public Function UpdateStatus(ByVal x As Long, width As Long, _
height As Long, Stext As String, Stage As Long)

' DEBUG Exit Function
'If (x Mod 2) <> 0 Then Exit Function

' If you want to use the Render method of
' the StdPicture object then uncomment the
' lines below.
' Max param accepted = Image height
'If x > m_PB1.ScaleY(m_PB1.Picture.height) Then
'    Set m_PB2.Picture = LoadPicture
'    x = m_PB1.ScaleY(m_PB1.Picture.height) - (x - m_PB1.ScaleY(m_PB1.Picture.height))
'End If

' Min param accepted = 1
If x <= 1 Then x = 1

If Not PB1 Is Nothing Then
  
    If Not PB2 Is Nothing Then
        ' If you want to use the Render method of
        ' the StdPicture object then uncomment the
        ' lines below.
        'm_PB1.ScaleMode = vbPixels
        'm_PB1.Picture.Render m_PB2.hDC, 0, 0, CSng(width), CSng(x), _
        '0, m_PB1.Picture.height, m_PB1.Picture.width, -m_PB1.Picture.height, 0&

        
        ' Render Status Text at bottom of PictureBox
        With PB2
            .ScaleMode = vbPixels
            .Cls
            .CurrentX = 2
            .CurrentY = .ScaleHeight - (2 * .TextHeight("T"))
            PB2.Print "Line :" & CLng(x) & " of " & m_linetotal
            PB2.Print Stext & ": Stage " & Stage & " of " & m_StageTotal
            .Refresh
          End With
    End If
End If

End Function


Private Sub Class_Initialize()
' Total Stages in this function
m_StageTotal = 3
End Sub
